// GeckoTIP by Ian Weiner, geckotip@hotmathematician.com
// See license.txt for licensing info (GPL)

var geckotip, tipPrefService, tipPref, tipPrefRoot, tipPbi, tipScopeOn;
var tipLastDesc, tipCurrentScopes;
var tipFlashUrlBar=false;
var tipCustom, tipProfDir, tipCustomFile, asURL, oLoader;

const tipPrefListener = {
  domain: "geckotip.",
  observe: function(subject, topic, prefName) {
    tipUpdate();
  }
}
function tipUpdate()
{
	tipScopeOn = tipPref.getBoolPref("scopingon");
	try { document.getElementById("tipEnabledBox-menuitem").setAttribute("checked",(!tipScopeOn)); } catch(err) { }
	try { document.commandDispatcher.focusedElement.blur(); } catch(err) { }
	tipBlur();
}

function tipInit()
{
	var Ci = Components.interfaces;	
	try { geckotip = Components.classes["@geckotip.mozdev.org/geckotip/fx18;1"].getService(Ci.iGeckotip);} 
	catch(err) { } //alert(document.getElementById("bundle_geckotip").getString(errmsg) + err); }

	tipPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
	tipPref = tipPrefService.getBranch("geckotip.");
	tipPrefRoot = tipPrefService.getBranch(null);
	tipPbi = tipPrefRoot.QueryInterface(Ci.nsIPrefBranchInternal);
	tipPbi.addObserver(tipPrefListener.domain, tipPrefListener, false);
	
	/*
	var dir = Components.classes["@mozilla.org/file/directory_service;1"].getService(Ci.nsIDirectoryService);
	tipCustomFile = dir.QueryInterface(Ci.nsIProperties).get("ProfD", Ci.nsILocalFile);
	tipCustomFile.appendRelativePath("geckotip-custom.js");
	asURL=encodeURI("file:///" + tipCustomFile.path);
	//asURL="file:///C:/Documents%20and%20Settings/Administrator/Application%20Data/Mozilla/Firefox/Profiles/8rx8gvrv.default/geckotip-custom.js";
	oLoader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].getService(Ci.mozIJSSubScriptLoader);
	oLoader.loadSubScript(asURL, tipCustom); 
	*/

	tipUpdate();
	window.addEventListener("blur",tipBlur,true);
	window.addEventListener("focus",tipFocus,true);
	window.addEventListener("dblclick",tipDebug,true);	//DEBUG
	window.addEventListener("input",tipFlashXUL,false);		// needed to fix Firefox caret tracking bug in XUL textboxes
	document.addEventListener("DOMNodeInserted",tipNewDOMNodeHandler,false); // needed to fix URL bar focus on new tab creation bug
}

function tipNewDOMNodeHandler(e)
{
	if (e.target) {
		if (e.target.nodeName=="tabbrowser") {
			tipFlashUrlBar=true;
		}
	}	
	return true;
}

function getUnicodePref(prefName,prefBranch) {
    try { return prefBranch.getComplexValue(prefName, Components.interfaces.nsISupportsString).data; } 
	catch(err) { return ""; }
}
function setUnicodePref(prefName,prefValue,prefBranch) {
    var sString = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
    sString.data = prefValue;
    prefBranch.setComplexValue(prefName,Components.interfaces.nsISupportsString,sString);
}

function tipBlur()
{
	try { document.getElementById("geckotip-panel-label").value = "---"; } catch(err) {}
	try { document.getElementById("tip-guess-menuitem").setAttribute("disabled","true"); } catch(err) {}
	geckotip.unfocused();
}

function tipToggleInk()
{	
	tipPref.setBoolPref("scopingon",(!tipScopeOn));
}

function tipGetKey(fe)
{
	if (fe==null) return "";
	var tn = fe.tagName;
	if (!((tn=="html:input")||(tn=="TEXTAREA")||(tn=="INPUT"))) return "";
	var desc=tipElementDescriptor(fe).d;
	if ((desc=="{}")||(desc=="")) return ""; 
	if (fe.ownerDocument.location.hostname=="") return "";
	return fe.ownerDocument.location.hostname + ":" + desc;
}

function tipSetRecog(s) 
{
	var fe = document.commandDispatcher.focusedElement;
	feKey = tipGetKey(fe); 
	if (feKey=="") return false;
	if (s>=0) {
		tipSetScope(s,false); 
		setUnicodePref("scope." + feKey, s, tipPref);
	}
	else {
		tipSetScope(IS_DEFAULT,false);
		tipPref.clearUserPref("scope." + feKey);
	}
	fe.blur();
	fe.focus();
	return true;
}

function tipGetAdjacentText(td)
{

/*
	  	var x = doc.evaluate("//text()", td, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE,null);
	  	if (x) {
	     	for (i=0; i<x.snapshotLength; i++) {
    	     	text = text + x.snapshotItem(i).nodeValue;     	 
         	}
      	}
		return text;
*/

	var text;
	if (!(td)) return "";
	var colcount=0; rowDone=false;

	var tr = td.parentNode;
	while (td && (!rowDone)) {
		text = td.textContent;
		if (text) {
			if (text.search(/\S/) != -1) { 
				text = text.replace(/\s+/g,"_");
				if (text.length > 20) rowDone=true;
				else return "{" + text + "}";
			}
		}
		colcount = colcount + td.colSpan;
		td = td.previousSibling;
	}
	tr = tr.previousSibling;
	rowDone=false;
	while (tr && (!rowDone)) {
		td = tr.childNodes(0);
		while ((td)&&(colcount>0)) {
			colcount = colcount - td.colSpan;
			if (colcount<=0) {
				text = textOf(td);
				if (text) {
					if (text.search(/\S/) != -1) {
						text = text.replace(/\s+/g,"_");
						if (text.length > 20) rowDone=true;
						else return "{" + text + "}";
					}
				}		
			}
		}
		tr = tr.previousSibling;
	}
	return "{}";
}

function tipElementDescriptor(e)
{
	var gotID=false, gotName=false, tableElem, desc="";
	var ename;

	while ( (e.getAttribute) && ((!gotID)||(!gotName)||(!(tableElem))) )
	{
		if ((!gotID)&&(e.getAttribute("id"))) {
			gotID = true;
			desc=desc + "i[" + e.getAttribute("id") + "]l[" + label_for(e.getAttribute("id")) + "]";			
		}
		if ((!gotName)&&(e.getAttribute("name"))) {
			gotName = true;
			desc=desc + "n[" + e.getAttribute("name") + "]";			
		}
		ename=e.nodeName; if (ename) ename = ename.toLowerCase();
		if ((!(tableElem))&&(ename=="td")) tableElem = e;
		try { e=e.parentNode; } 
		catch(e) { 
			desc="{" + desc+ "}"; 
			return { d: desc.toLowerCase(), t:tipGetAdjacentText(tableElem).toLowerCase() }; 
		}
	}
	desc="{" + desc+ "}"; 
	return { d: desc.toLowerCase(), t:tipGetAdjacentText(tableElem).toLowerCase() }; 
}

function label_for(id)
{
	var labels = document.getElementsByTagName("label");
	for (var i=0;i<labels.length;i++) 
		if (labels[i].htmlFor) 		
			if (labels[i].htmlFor==id)  return labels[i].textContent;
	return "";
}

function tipFocusedOnItem()
{
	var fw = document.commandDispatcher.focusedWindow;
	if (fw) {
		if (fw.document) {
			// editor mode in firefox, e.g. Gmail HTML email editor
			if (fw.document.designMode) {
				if (fw.document.designMode=="on") return true;
			}
		}
		// thunderbird composition
		if (fw.name=="browser.message.body") return true;
	}
	var fe = document.commandDispatcher.focusedElement;
	if (fe==null) return false;
	var tn = fe.tagName; var et = fe.type; if (et) et=et.toLowerCase();
	if ((tn=="html:input")||(tn=="TEXTAREA")) return true;
	if (tn=="INPUT") {
		if ((et=="")||(et=="text")||(et=="password")||(et=="file")) return true;
	}
	return false;
}

function tipFocus()
{
	geckotip.focused();
	tipLastDesc = "N/A"; //debug
	if (!tipFocusedOnItem()) { tipBlur(); return true; }
	var fe = document.commandDispatcher.focusedElement;
	if (fe==null) { tipSetScope(IS_DEFAULT, false); return true; }

	var feKey = tipGetKey(fe);

	// hack to fix URL bar not focusing properly when new tab is made
	if (tipFlashUrlBar) {
		tipFlashUrlBar=false;
		if (feKey=="browser:{i[urlbar]l[]}") {
			if (fe.value=="") {
				fe.blur();
				fe.focus();
			}
		}
	}

	if (feKey != "") {
		var s = getUnicodePref("scope." + feKey, tipPref);
		if (s != "") {						
			tipSetScope(1*s,false);
			document.getElementById("tip-guess-menuitem").setAttribute("disabled","false");
			return true;
		}
	}

	var tn = fe.tagName;
	var type = fe.getAttribute("type");
	if (type) type = type.toLowerCase();
	if (tn=="INPUT") {
		if (type=="password")
			{ tipSetScope(IS_PASSWORD, false); return true; }
		else if (type=="file")
			{ tipSetScope(IS_FILE_FULLFILEPATH, false); return true; }
		else if (type=="text" || type==null)
		{
			// it might be the anonymous child of a file input
			if (fe.parentNode.tagName == "INPUT")
			{
				var pt = fe.parentNode.type;
				if (pt) pt = pt.toUpperCase();
				if (pt=="FILE")
				{
					tipSetScope(IS_FILE_FULLFILEPATH, false); 
					return true;
				}
			}
		}
	}

	if (!tipScopeOn) { tipSetScope(IS_DEFAULT, false); return true; }

	var noScopeYet=true;
	// at this point we're done with special cases, lets try guessing scopes
	if ((tn=="html:input")||(tn=="TEXTAREA")||(tn=="INPUT")) 
	{
		var descs = tipElementDescriptor(fe);
		var desc = descs.d + "t:"+descs.t;
		tipLastDesc=desc; //debug
		var i, re;
		
		for (i=0; i < tipMatches.length; i++) 
		{
			if (desc.search(tipMatches[i].pattern) != -1) {
				if (noScopeYet) { 
					tipSetScope(tipMatches[i].code,false); 
					noScopeYet = false; 
				} else { 
					tipSetScope(tipMatches[i].code,true); 
				}
			}
		}
		for (i=0; i < tipGlobalMatches.length; i++) 
		{
			if (desc.search(tipGlobalMatches[i].pattern) != -1) {
				if (noScopeYet) { 
					tipSetScope(tipGlobalMatches[i].code,false); 
					noScopeYet = false; 
				} else { 
					tipSetScope(tipGlobalMatches[i].code,true); 
				}
			}
		}
	}
	if (noScopeYet) tipSetScope(IS_DEFAULT, false);
	return true;
} 

function tipSetScope(s, add) 
{
	var bx = document.getElementById("geckotip-panel-label");
	var tipBundle = document.getElementById("bundle_geckotip");
	
	if (add) {
		geckotip.addScope(s);
		if (tipBundle) tipCurrentScopes = tipCurrentScopes + "/" + tipBundle.getString("tipScope" + s);
	} else {
		geckotip.setScope(s);
		if (tipBundle) tipCurrentScopes = tipBundle.getString("tipScope" + s);
	}
	if (bx) {
		bx.value = tipCurrentScopes;
		if (!tipScopeOn) bx.value = "(" + bx.value + ")";
	}
}

function tipDebug()
{
	geckotip.toggleDebug();
	//if (!tipCustom) alert("tipcustom failed");//DEBUG
	//else alert("tipcustom OK");	//DEBUG
}


function tipFlashXUL()
{
	var x = document.commandDispatcher.focusedElement;
	if (!x) return true; 
	if (x.tagName == "html:input") {
		x.setSelectionRange(x.selectionEnd,x.selectionEnd);
	}
	return true;
}

function tipSendEnter() 
{
	var x = document.commandDispatcher.focusedElement;
	if (!x) return;
	var ev = document.createEvent("KeyEvents");
	ev.initKeyEvent("keypress", true, true, window, false, false, false, false, 13, 13);
	x.dispatchEvent(ev); 
}
